###############################################
# FILE: clausal100.pat
# SUBJ: Form-fit clausal phrases prior to segmentation.
# AUTH: AM
# CREATED: 02/May/02 09:57:23
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par

# prep np collection.
@POST
  group(2,5,"_np");
@RULES
_xNIL <-
	_xWILD [s one match=(_prep)]
	_xWILD [s one match=(another _det)]
	_adv [opt]
	_xALPHA
	_noun [s plus]
	_xWILD [s one lookahead match=( \) _modal _have _be _verb
		_vg _adv _advl _xEOS _xEND )]
	@@

# to verb verbing
# Make sure first isn't a helping verb...
# Assume these haven't fit the mhbv patterns.
@CHECK
  G("tmp") = vconj(N(3));	# New stuff. # 05/03/02 AM.
  if (G("tmp") != "-ing")
    fail();
  if (!N("noun",4))
    fail();
@POST
  # Can't operate after splice, so hack something up.
  # Add a noun sense if absent.
  S("tmp") = pndown(N(3));
  if (!pnvar(S("tmp"),"noun"))
    {
    S("num") = pnvar(S("tmp"),"pos num");
    pnreplaceval(S("tmp"),"pos num", ++S("num"));
    pnreplaceval(S("tmp"),"noun", 1);
    }
  splice(3,3);	# Zap the verb top-level node,
  	# To allow this to be a possible adj.
@RULES
_xNIL <-
	to [s]
	_verb
	_verb
	_xWILD [one lookahead match=(_xALPHA)]
	@@

@CHECK
  if (N(4))
  	{
	if (!N("noun",4) && !N("adj",4) && !N("unknown",4))
	  fail();
	if (!N("noun",3) && !N("adj",3) && !N("unknown",3))
	  fail();
	}
  else if (N(3))
  	{
	if (!N("noun",3) && !N("adj",3) && !N("unknown",3))
	  fail();
	}
@POST
  if (N(4))
    S("head") = N(4);
  else if (N(3))
    S("head") = N(3);
  else
    S("head") = N(2);
  pncopyvars(S("head"));
  singler(1,4);
@RULES
_np <-
	_xWILD [s one match=(_det) except=(_fnword)]
	_xALPHA
	_xALPHA [opt]
	_xALPHA [opt]
	_verb [lookahead]
	@@

# ving noun of
@CHECK
	if (!N("verb",1))
		fail();
	S("text") = strtolower(N("$text",1));
	if (!strendswith(S("text"),"ing"))
		fail();
@POST
  group(1,1,"_verb");
@RULES
_xNIL <-
	_xALPHA
	_noun [lookahead]
	_xWILD [s one match=(of)]
	@@

# the prep
# det prep
@POST
  splice(2,2);
@RULES
_xNIL <-
	_xWILD [s one match=(the)]
	_prep
	_xWILD [s one lookahead match=(_xNUM _num _quan _adv _advl
		several few)]
	@@

# paren acronym
@RULES
_advl [layer=_acro] <-
	\( [s]
	_xALPHA
	\) [s]
	@@
_num <-
	\(
	_xNUM
	\)
	@@

# "num"
# "noun"
@POST
  excise(3,3);
  excise(1,1);
@RULES
_xNIL <-
	\"
	_xWILD [one match=(_num _noun)]
	\"
	@@

# Some parallel construction...
@POST
  S("txt") = strtolower(N("$text",5));
  if (N("verb",2) && N("noun",3) && N("noun",6)
   && strendswith(S("txt"),"ed") )
  	{
	group(5,5,"_adj");	# OVERRIDE verb sense.
	setbase(5,"true");
	group(2,2,"_adj");
	}
    
@RULES
_xNIL <-
	_det
	_xALPHA
	_xALPHA
	_conj
	_verb
	_xALPHA
	@@

# Idiom: in writing
@POST
  group(3,3,"_noun");
  group(3,3,"_np");
  setbase(3,"true");
@RULES
_xNIL <-
	_vg
	in [s]
	writing [s]
	@@

# adj conj adj
@CHECK
  if (N("adj",3))
    succeed();
  S("tmp") = vconj(N(3));
  if (S("tmp") == "-ed"
   || S("tmp") == "-edn"
   || S("tmp") == "-en"
   )
   succeed();
  fail();
@POST
  if (!N("sem",3))
    N("sem",3) = N("$text",3);
  if (!N("stem",3))
    N("stem",3) = N("$text",3);
  S("sems")[0] = N("sem",1);
  S("sems")[1] = N("sem",3);
  S("stems")[0] = N("stem",1);
  S("stems")[1] = N("stem",3);
  group(3,3,"_adj");
  single();
@RULES
_adj <-
	_adj [s]
	_conj [s]
	_xALPHA
	@@

# vg verb noun
# ... will eat spoiled food
@CHECK
  S("vconj") = vconj(N(2));
  if (S("vconj") != "-en"
   && S("vconj") != "-edn"
   && S("vconj") != "-ing" )
    fail();
@POST
  group(2,2,"_adj");
  setbase(2,"true");
@RULES
_xNIL <-
	_vg
	_verb
	_noun
	@@

# adj verb noun
# happy working conditions.
@CHECK
  S("vconj") = vconj(N(2));
  if (S("vconj") != "-ing"
   && S("vconj") != "-en"
   && S("vconj") != "-edn" )
    fail();
@POST
  group(2,2,"_adj");
  setbase(2,"true");
  "dict.txt" << "'" << N("$text",2) << "' => ADJ" << "\n";
@RULES
_xNIL <-
	_adj
	_verb
	_noun
	_xWILD [s one lookahead match=(_qEOS _xPUNCT)]
	@@

@CHECK
  if (!N("verb",4))
  	fail();
@POST
  S("tmp") = N(4);
  group(2,2,"_adv");
  group(4,4,"_verb");
  pncopyvars(S("tmp"),N(4));
@RULES
_xNIL <-
	_xWILD [s one match=( _xPUNCT _fnword)]
	please [s]
	_xWILD [s star match=(_adv _advl)]
	_xALPHA
	@@

# alpha to
@CHECK
  if (!N("verb",1))
    fail();
  S("tmp") = vconj(N(1));
  if (S("tmp") != "-edn"
   && S("tmp") != "-en"
   && S("tmp") != "-ed"
   )
    fail();
@POST
  S("tmp") = N(1);
  group(1,1,"_verb");
  group(1,1,"_vg");
  pncopyvars(S("tmp"),N(1));
@RULES
_xNIL <-
	_xALPHA
	to [s lookahead]
	@@

# Not a good rule.  Need more context. # 09/05/02 AM.
# again showed
# adv alpha
@CHECK
  if (!N("verb",2))
    fail();
  S("vconj") = vconj(N(2));
  if (S("vconj") != "-edn"
   && S("vconj") != "-ed"
   && S("vconj") != "-en"
   && S("vconj") != "-ing")
    fail();
@POST
  S("tmp") = N(2);
  group(2,2,"_verb");
  group(2,2,"_vg");
  pncopyvars(S("tmp"),N(2));
@RULES
_xNIL <-
	_xWILD [s one match=(again)]	# 09/05/02 AM.
	_xALPHA
	@@

# pro alpha
# fnword alpha
@CHECK
  if (!N("verb",2))
    fail();
  S("vconj") = vconj(N(2));
  if (S("vconj") != "-edn"
   && S("vconj") != "-ed"
   && S("vconj") != "-en"
   && S("vconj") != "-ing")
    fail();
@POST
  S("tmp") = N(2);
  group(2,2,"_verb");
  group(2,2,"_vg");
  pncopyvars(S("tmp"),N(2));
@RULES
_xNIL <-
	_xWILD [s one match=(_proSubj _fnword)]
	_xALPHA
	@@

# alpha that
@CHECK
  if (!N("verb",1))
    fail();
  S("vconj") = vconj(N(1));
  if (S("vconj") != "-edn"
   && S("vconj") != "-ed"
   && S("vconj") != "-en"
   && S("vconj") != "-ing")
    fail();
@POST
  S("tmp") = N(1);
  group(1,1,"_verb");
  group(1,1,"_vg");
  pncopyvars(S("tmp"),N(1));
@RULES
_xNIL <-
	_xALPHA
	that [s trigger]
	@@
