###############################################
# FILE: clause100.pat
# SUBJ: Clause and event level patterns.
# AUTH: AM
# CREATED: 25/Apr/02 08:54:08
# MODIFIED:
###############################################

@CODE
"dump.txt"
	<< "\n"
	<< "[PASS: clause100. Syntactic Collection of Clauses.]"
	<< "\n\n";
@@CODE

@PATH _ROOT _TEXTZONE _par _sentence

# "... , as is John."
@POST
  S("anaphoric event") = 1;	# Need to resolve based on previous.
  # resolver is immediately prior clause.
  singler(1,3);
@RULES
_clause [base] <-
	as [s]
	_vg
	_xWILD [one match=(_np _nps)]
	_xWILD [s opt lookahead match=(_dbldash _qEOS _xPUNCT)]
	@@


#@POST
#  excise(3,3);
#@RULES
#_xNIL <-
#  _xSTART
#  _advl
#  \,
#  @@

# Some highly constrained clauses.


# np vg np prep np
@POST
  if (N("passive",5))
    {
	# If 2nd np is there, then erroneous match.
	}
  else # active
    {
	if (N(3))
	  S("actor") = N(3);
	# else if infinitive, possibly imperative.
	S("act") = N(5);
	S("dobj") = N(7);
	S("part") = N(9);
	S("iobj") = N(11);
	}

  singler(3,11);
@RULES
_clause [base] <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s opt match=(_np _nps this)]	# 3
	_xWILD [s star match=(_adv _advl)]
	_vg					# 5
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]	# 7
	_xWILD [s star match=(_adv _advl)]
	_prep	# 9
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]	# 11
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(
		_clause that which _xPUNCT _qEOS _conj _xEND)]
	@@
_clause [base] <-
	_xWILD [s one match=( _xPUNCT _dbldash _fnword to)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_prep
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(
		_clause that which _xPUNCT _qEOS _conj _xEND)]
	@@

# np vg np np	# 09/06/02 AM.
# Need nvnn pattern...
@POST
  if (N("passive",5))
    {
	# If 2nd np is there, then erroneous match.
	}
  else # active
    {
	if (N(3))
	  S("actor") = N(3);
	# else if infinitive, possibly imperative.
	S("act") = N(5);
	S("dobj") = N(7);
	S("iobj") = N(9);
	}

  singler(3,9);
@RULES
_clause [base] <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s opt match=(_np _nps this)]	# 3
	_xWILD [s star match=(_adv _advl)]
	_vg					# 5
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]	# 7
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]	# 9
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(
		_clause that which _xPUNCT _qEOS _conj _xEND)]
	@@
_clause [base] <-
	_xWILD [s one match=( _xPUNCT _dbldash _fnword to _conj)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)] # 9
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(
		_clause that which _xPUNCT _qEOS _conj _xEND)]
	@@


# [np] vg [np] prep
@POST
  if (N("passive",5))
    {
	# If 2nd np is there, then erroneous match.
	}
  else # active
    {
	if (N(3))
	  S("actor") = N(3);
	# else if infinitive, possibly imperative.
	S("act") = N(5);
	if (N(7))
	   S("dobj") = N(7);
	S("part") = N(9);
	}

  singler(3,9);
@RULES
_clause [base] <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s opt match=(_np _nps this)]	# 3
	_xWILD [s star match=(_adv _advl)]
	_vg					# 5
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]	# 7
	_xWILD [s star match=(_adv _advl)]
	_prep	# 9
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(
		_clause that which _xPUNCT _qEOS _conj _xEND)]
	@@
_clause [base] <-
	_xWILD [s one match=( _xPUNCT _dbldash _fnword to _conj)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_prep
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(
		_clause that which _xPUNCT _qEOS _conj _xEND)]
	@@


# NP VG NP ADJ
# John painted Mary green.
@CHECK
  if (N("glom right",9))
    fail();
@POST
  if (N("passive",5))
    {
	# If 2nd np is there, then erroneous match.
	}
  else # active
    {
	if (N(3))
	  S("actor") = N(3);
	# else if infinitive, possibly imperative.
	if (N(5))
	  S("act") = N(5);
	if (N(7))
	  S("dobj") = N(7);
	else
	  nvj(N(2),N(3),N(4),N(5),N(6),N(9),N(10));
	S("adj role") = N(9);
	}

  singler(3,10);
@RULES
_clause [base] <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_vg [opt] # Should be copula
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_adj
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(
		_clause that which _xPUNCT _qEOS _conj _prep
		_vg _np _nps _xEND)]
	@@

@CHECK
  if (N("glom right",9))
    fail();
@POST
  if (N("passive",5))
    {
	# If 2nd np is there, then erroneous match.
	}
  else # active
    {
	if (N(3))
	  S("actor") = N(3);
	# else if infinitive, possibly imperative.
	if (N(5))
	  S("act") = N(5);
	if (N(7))
	  {
	  # Ignoring the adjectival phrase for now.	# 08/05/02 AM.
	  nvn(N(2),N(3),N(4),N(5),N(6),N(7),N(8));
#	  S("dobj") = N(7);
	  }
	else
	  nvj(N(2),N(3),N(4),N(5),N(6),N(9),N(10));
	S("adj role") = N(9);
	}
  singler(3,9);
@RULES
_clause [base] <-
	_xWILD [s one match=(_xPUNCT _dbldash _fnword _conj _prep 
		_clause _complex)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_vg [opt] # Should be copula
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_adj
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(
		_clause _complex _fnword that which _xPUNCT _qEOS
		_conj _prep _vg _xEND)]
	@@

@POST
  nvn(N(2),N(3),N(4),N(5),N(6),N(7),N(8));
  if (N(7))
    singler(3,8);
  else
    {
	if (N("glom left",6))
	  singler(3,6);
	else
      singler(3,5);
	}
@RULES
_clause [base] <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(
		_clause that which _xPUNCT _qEOS _prep _fnword _conj _vg
		_prep _xEND)]
	@@

# Todo: Check for passive + 2nd np.  Should fail on that.
@POST
  nvn(N(2),N(3),N(4),N(5),N(6),N(7),N(8));

  if (N(7))
    singler(3,8);
  else
    singler(3,6);
@RULES
_clause [base] <-
	_xWILD [s one match=(_xPUNCT _dbldash
		 _fnword _conj _clause _complex
		_prep _vg _adj)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s opt match=(_np _nps) except=(_proSubj)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(
		_clause that which _xPUNCT _qEOS _fnword _conj _vg
		_prep _xEND)]
	@@
@POST
  if (N("passive",5))
    {
	# If 2nd np is there, then erroneous match.
	}
  else # active
    {
	if (N(3))
	  S("actor") = N(3);
	# else if infinitive, possibly imperative.
	S("act") = N(5);
	S("part") = N(7);
	S("dobj") = N(9);
	}
  singler(3,9);
@RULES
_clause [base] <-
	_xWILD [s one match=( _xPUNCT _dbldash _fnword to)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_prep
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(
		_clause that which _xPUNCT _qEOS _conj _xEND)]
	@@
_clause [base] <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_xWILD [opt match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_prep
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(
		_clause that which _xPUNCT _qEOS _conj _xEND)]
	@@

# Intransitive.
@POST
  if (N("passive",5))
    {
	# If 2nd np is there, then erroneous match.
	}
  else # active
    {
	if (N(3))
	  S("actor") = N(3);
	# else if infinitive, possibly imperative.
	S("act") = N(5);
	}
  singler(3,5);
@RULES
_clause [base] <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	\, [s opt]
	_xWILD [s one lookahead match=(
		_clause that which _prep _qEOS \: _xEND)]
	@@
_clause [base] <-
	_xWILD [s one match=(_fnword _prep)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	\, [s opt]
	_xWILD [s one lookahead match=(
		_clause that which _prep _qEOS \: _xEND)]
	@@

# No subject...

@POST
  if (N("passive",5))
    {
	# If 2nd np is there, then erroneous match.
	}
  else # active
    {
	# else if infinitive, possibly imperative.
	S("act") = N(3);
	S("dobj") = N(5);
	}
  singler(3,5);
@RULES
_clause [base] <-
	_xWILD [s one match=(that which _fnword _prep)]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(
			_qEOS \: _fnword _complex \, _vg _xEND)]
	@@


# Lone verb group should be at the end here.
@POST
  S("act") = N(3);
  singler(3,4);
@RULES
_clause [base] <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(_qEOS \: _xEND)]
	@@
_clause [base] <-
	_xWILD [s one match=(_conj \, _fnword _prep _clause)]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(_qEOS \: _complex \, _conj
		 _xEND)]
	@@

# Some complex clause collection, to help parse a sentence.
#@POST
#  singler(3,5);
#@RULES
#_complex <-
#	\, [s opt]
#	_xWILD [s star match=(_adv _advl)]
#	_xWILD [s plus match=(_prep _fnword)]
#	_xWILD [s star match=(_adv _advl)]
#	_clause
#	_xWILD [s star match=(_adv _advl)]
#	_xWILD [one lookahead match=(_qEOS \: _clause _complex _xEND)]
#	@@

@POST
  singler(3,4);
@RULES
_complex [base] <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(_prep)]
	_clause [s]
	\, [s lookahead]
	@@

#_complex <-
#	_xSTART
#	_xWILD [s plus match=(_adv _advl)]
#	\, [s opt]
#	_clause [s]
#	@@

#@POST
#  singler(1,2);
#@RULES
#_complex <-
#	_clause [s]
#	_xWILD [s plus match=(_adv _advl)]
#	_xWILD [s one match=( _qEOS \: )]
#	_xEND
#	@@

# Some ellipsis.
# "waste trapped by x is added ..."
@POST
	singler(1,1);
@RULES
_clause [base layer=(_advl)] <-
	_vg
	_xWILD [s star match=(_adv _advl)]
	_vg [lookahead]
	@@

# VERBLESS NP clauses (may indicate segmentation error).
@CHECK
  if (!N(1) && !N(2))
    fail();
@POST
  S("verbless error?") = 1;
  singler(4,4);
@RULES
_clause [base] <-
#	_xWILD [s opt match=( \, _dbldash _conj)]
	_xWILD [s one match=(_dbldash)]
	_fnword [s opt]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one lookahead match=(_qEOS \: _fnword _complex
		_clause _xEND)]
	@@


#@POST
#  singler(3,3);
#@RULES
#_clause [base] <-
#	_xSTART
#	_xWILD [s star match=(_adv _advl)]
#	_xWILD [one match=(_np _nps)]
#	_xWILD [s star match=(_adv _advl)]
#	_xWILD [one lookahead match=(_qEOS \: \, _conj _fnword
#		_complex _clause _xEND)]
#	@@

## ADJECTIVE CLAUSE.

# Using this pattern for instant anaphoric resolution.
@CHECK
  if (!N("glom right",3))
	fail();
@POST
  nvj(0,N(1),N(2),0,0,N(3),N(4));
  S("np resolver") = N(1);  # Resolves missing np.
  S("act stem") = "be";
  S("adj role") = N(3);
  singler(2,4);
@RULES
_clause [base] <-
	_np [s]
	_xWILD [s star match=(_adv _advl)]
	_adj [s]
	_xWILD [s plus match=(_adv _advl)]
	@@

@CHECK
  if (!N("glom right",1))
	fail();
@POST
  S("adj role") = N(1);
  single();
@RULES
_clause [base] <-
	_adj [s]
	_xWILD [s plus match=(_adv _advl)]
	@@

# ADVERBIAL CLAUSE.
#@POST
#  singler(1,2);
#@RULES
#_clause <-
#	_xWILD [s one match=( \, )]
#	_xWILD [s plus match=(_adv _advl)]
#	_xWILD [s one lookahead match=( _qEOS \: _xEND)]
#	@@

# Embedded clauses.
@RULES
_np [base] <-
	_np [s]
	of [s]
	_xWILD [s star match=(_adv _advl)]
	_clause [s]
	@@

@RULES
_advl <-
	_xWILD [s one match=(_adv _advl)]
	_conj [s]
	_xWILD [s one match=(_adv _advl)]
	@@

@POST
  S("pattern") = "that-clause";
  N("pattern",3) = "that-clause";
  S("clause") = N(3);
  singler(2,3);
@RULES
_advl <-
	\, [s opt]
	_xWILD [s one match=(which that)]
	_clause
	\, [s opt]
	@@

#_advl <-
#	\, [s]
#	_xWILD [s plus match=(_adv _advl)]
#	\, [s]
#	@@

# for this to happen...
@POST
  singler(1,4);
@RULES
_clause <-
	for [s]
	_xWILD [s one match=(_np _nps)]
	to [s]
	_clause [s]
	\, [s lookahead opt]
	@@

@POST
  singler(2,4);
@RULES
_complex <-
	_xWILD [s one match=(_prep _fnword)]
	_clause
	_conj [s]
	_clause
	@@
_complex <-
	_xSTART
	_clause
	_conj [s]
	_clause
	_xWILD [s one match=(_qEOS _xEND)]
	@@

# that, if quickly thwarted, will ...
# fnword fnword
@POST
  singler(2,7);
@RULES
_complex [layer=_advl] <-
	_fnword [s]
	\, [s opt]
	_fnword [s]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(_clause _complex)]
	_xWILD [s star match=(_adv _advl)]
	\, [s opt]
	_xWILD [s one lookahead match=(_clause _complex)]
	@@

@POST
 S("clause") = N(2);
 S("pp") = 1;
 singler(1,2);
@RULES
_advl <-
	_prep
	_xWILD [one match=(_clause _complex)]
	_xWILD [s one lookahead fail=(_conj)]
	@@

@RULES
_advl <-
	\( [s]
	_clause
	\) [s]
	@@

# Collect junk.
_advl <-
	\( [s]
	_xANY
	\) [s]
	@@

# At some point, got to do this...
_advl <-
	\( [s]
	_xWILD
	\) [s]
	@@

#@POST
#  singler(1,4);
#@RULES
#_advl <-
#	\: [s]
#	_xWILD [s star match=(_adv _advl)]
#	_xWILD [s one match=(_np _nps)]
#	_xWILD [s star match=(_adv _advl)]
#	_xWILD [s one lookahead match=(_qEOS \: _xEND)]
#	@@

# Some clause level segment assignment.
@CHECK
  if (!N("verb",4) && (N("seg type",4) != "np"))
  	fail();
@POST
  pnrename(N(4),"_vg");
  N("id",4) = "cl100 01";	# for tracing.
@RULES
_xNIL <-
	_xSTART
	_xWILD [s one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_seg
	_xWILD [s star match=(_adv _advl)]
	@@

@CHECK
  if (N("last noun",3))
    succeed();
  if (N("seg type",3) == "np")
    succeed();
  if (N("seg nouns",3))
    succeed();
  fail();
@POST
  pnrename(N(3),"_np");
  N("id",3) = "cl100 02";	# for tracing.
@RULES
_xNIL <-
	_xWILD [s one match=(_clause _complex)]
	\, [s opt]
	_seg
	_xWILD [s one lookahead match=(_vg _xEND)]
	@@

@CHECK
  if (N("last noun",4))
    succeed();
  if (N("seg type",4) == "np")
    succeed();
  if (N("seg nouns",4))
    succeed();
  fail();
@POST
  pnrename(N(4),"_np");
  N("id",4) = "cl100 03";	# for tracing.
@RULES
_xNIL <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	\, [s opt]
	_seg
	_xWILD [s one lookahead match=(_vg)]
	@@


@CHECK
  if (!vgseg(N(3)))
    fail();
@POST
  pnrename(N(3),"_vg");
  N("id",3) = "cl100 04";	# for tracing.
@RULES
_xNIL <-
	_xWILD [s one match=(_fnword _conj)]
	_xWILD [s star match=(_adv _advl)]
	_seg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s opt match=(_np _nps)]
	_xWILD [s one lookahead match=(_qEOS _xEND)]
	@@

# Some turds.
#@POST
#  excise(2,2);
#@RULES
#_xNIL <-
#	_xWILD [s one match=(_np _nps)]
#	\, [s]
#	_xWILD [s one lookahead match=(_vg)]
#	@@

@POST
  singler(1,1);
@RULES
_advl [base] <-
	_xWILD [s one match=(there)]
	_xWILD [s one lookahead match=(_qEOS \:)]
	@@

# Some stragglers...
@POST
  pncopyvars(5);
  singler(4,6);
@RULES
_clause [base] <-
	_xWILD [s one match=(_clause _complex)]
	_xWILD [s star match=(_adv _advl)]
	_conj [s]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(_qEOS \: _clause _complex
		_xEND )]
	@@

# Some repair.
@POST
  listadd(1,3,"true");
@RULES
_xNIL <-
	_advl
	_conj
	_np
	_np [lookahead]
	@@

@POST
  group(3,3,"_noun");
  group(3,3,"_np");
  group(2,3,"_adv");
  N("pp",2) = 1;
@RULES
_xNIL <-
	_xWILD [s one match=(_clause _complex)]
	_prep
	_xWILD [s one match=(_adj those)]
	_xWILD [s one lookahead match=(_clause _complex)]
	@@

# Adverbial stragglers.
# E.g., "first" can be an adverbial.
@CHECK
  if (!N("adv"))
    fail();
@RULES
_adv <-
	_xWILD [one match=(_num)]
	@@

# Some glomming.
# adv clause adv
@POST
  N("list",2) = 1;
  listadd(1,2,"false");
@RULES
_xNIL <-
	_clause
	_xWILD [s one match=(_adv _advl)]
	_xWILD [one match=(_qEOS _xEND)]
	@@
_xNIL <-
	_clause
	_xWILD [s plus group=_advl match=(_adv _advl)]
	_xWILD [one match=(_qEOS _xEND)]
	@@

@POST
  listadd(3,2,"false");
@RULES
_xNIL <-
	_xSTART
	_xWILD [s one match=(_adv _advl)]
	_clause
	@@

