###############################################
# FILE: clause50.pat
# SUBJ: Early stages of clause processing
# AUTH: AM
# CREATED: 20/May/02 11:18:43
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par _sentence

@RULES
_vg <-
	_vg
	_xWILD [s star match=(_adv _advl)]
	\, [s]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	\, [s opt]
	_conj
	_xWILD [s star match=(_adv _advl)]
	_vg
	@@

@CHECK
  if (N("prep",6))
    fail();
  if (N("glom left",6) || N("glom right",5))
  	fail();
@POST
  singler(1,5);
@RULES
_vg <-
	_vg
	_xWILD [s star match=(_adv)] # _advl
	_conj
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xANY [s one lookahead]
	@@

@CHECK
  if (!N("verb",3))
    fail();
@POST
  pnrename(N(3),"_vg");
  N("id",3) = "cl50 01";	# for tracing.
@RULES
_xNIL <-
	_xWILD [s one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_seg
	_xWILD [s star lookahead match=(_adv _advl)]
	_xWILD [s one match=(_np _nps)]
	@@

# hold the X closest to Y.
# vg np adj prep np
# if the vg is not a linking verb,
# then the adj typically starts a separate clause.
# superlative adj also signals clause start.
@CHECK
  # Todo: check on verbs that link to adj.
  S("text") = strtolower(N("$text",5));
  if (!strendswith(S("text"),"est"))
    fail();
@POST
  N("glom left",3) = 1;
  N("glom right",5) = 1;
@RULES
_xNIL <-
	_vg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_adj [s]
	@@

# Glomming adverbials into lists.
# MAKE ADVL LIST.
@CHECK
  if (N("advl list",1) || N("advl list",2))
    fail();
@POST
  S("advl list") = 2;
  if (N("glom left",1))
    S("glom left") = 1;
  if (N("glom right",2))
    S("glom right") = 1;
  S("stems")[0] = N("stem",1);
  S("stems")[1] = N("stem",2);
  S("sems")[0] = N("sem",1);
  S("sems")[1] = N("sem",2);
  # 07/25/02 AM.
  if (N("clause",1) && N("clause",2))
    {
	S("clauses")[0] = N("clause",1);
	S("clauses")[1] = N("clause",2);
	}
  else if (N("clause",1))
    S("clause") = N("clause",1);
  else if (N("clause",2))
    S("clause") = N("clause",2);
  S("nps") = mergenps(N(1),N(2));
  domcompose(N(1),N(2));
  # Todo: establish a link between adverbials.
  single();
@RULES
_advl <-
	_xWILD [one match=(_adv _advl)]
	_xWILD [one match=(_adv _advl)]
	@@

# EXTEND ADVL LIST.
@CHECK
  if (!N("advl list",1))
    fail();
@POST
  N("stems",1)[N("advl list",1)] = N("stem",2);
  N("sems",1)[N("advl list",1)]  = N("sem",2);
  ++N("advl list",1);
  listadd(1,2,"false");
@RULES
_xNIL <-
	_advl
	_xWILD [one match=(_adv _advl)]
	@@

# Make conjoined list.
@CHECK
if (N("advl list",1))
  fail();
@POST
  S("stems")[0] = N("stem",1);
  S("stems")[1] = N("stem",3);
  S("sems")[0] = N("sem",1);
  S("sems")[1] = N("sem",3);
  S("advl list") = 2;
  singler(1,3);
@RULES
_advl <-
	_xWILD [one match=(_adv _advl)]
	_conj
	_xWILD [one match=(_adv _advl)]
	_xWILD [s star lookahead match=(_adv _advl)]
	_xWILD [s one match=(_qEOS _xEND)]
	@@

# Doing another np grammar here.
@CHECK
  if (N("sem",1) == "date"
   || N("sem",3) == "date"
   || N("sem",6) == "date")
    fail();
@POST
  # Collect in REVERSE order!	# 07/10/02 AM.
  S("stems")[0] = N("stem",6);
  S("stems")[1] = N("stem",3);
  S("stems")[2] = N("stem",1);
  S("nps")[0] = N(6);
  S("nps")[1] = N(3);
  S("nps")[2] = N(1);
  S("count") = 3;
  single();
@RULES
_nps <-
	_np
	\, [s]
	_np
	\, [s opt]
	_conj [s]
	_np
	@@

@CHECK
  if (N("sem",1) == "date")
    fail();
@POST
  # Collect in REVERSE order!	# 07/10/02 AM.
  N("stems",3)[N("count",3)] = N("stem",1);
  N("nps",3)[N("count",3)] = N(1);
  ++N("count",3);
  listadd(3,1,"false");
@RULES
_xNIL <-
	_np
	\, [s]
	_nps
	@@


# Some component processing.
@POST
  S("appositive") = 1;
  singler(1,2);
@RULES
_advl <-
	_ie [s]
	_xWILD [s one match=(_np _nps)]
	_xWILD [s star match=(_advl \, _adv)]
	_xWILD [s one match=(_qEOS _xEND)]
	@@

# Some apposition.
# np, i.e., np
@POST
  # Todo: set up vars for apposed nps...
  S("nps") = mergenps(N(1),N(5)); # Simplistic merge.
  single();
@RULES
_nps <-
	_xWILD [s one match=(_np _nps)]
	\, [s opt]
	_ie [s]
	\, [s opt]
	_xWILD [s one match=(_np _nps)]
	@@

# adj and adj
@POST
  S("stems")[0] = N("stem",1);
  S("stems")[1] = N("stem",4);
  single();
@RULES
_adj <-
	_adj
	_xWILD [s star match=(_adv _advl)]
	_conj
	_adj
	_xWILD [s star match=(_adv _advl)]
	@@

