###############################################
# FILE: compo1.pat
# SUBJ: Modal-have-be-verb (MHBV) primarily.
# AUTH: AM
# CREATED: 26/Feb/02 09:38:52
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par

# Glom date stuff together.
@POST
  ++S("don't splice");
  single();
@RULES
_date [layer=(_np)] <-
	_date [s plus]
	\, [opt]
	_date [s plus]
	@@

@POST
  group(2,2,"_np");
@RULES
_xNIL <-
	_xWILD [s one match=(_prep)]
	_xWILD [s one match=(_moWord)]
	_xWILD [s one lookahead match=( \, )]
	@@

# noun conj ving
# should be eventive noun.
@CHECK
  if (vconj(N(3)) != "-ing")
    fail();
@POST
  "dict.txt" << nodetext(N(3)) << "=> noun" << "\n";
  group(3,3,"_noun");
  setbase(3,"true");
@RULES
_xNIL <-
	_noun
	_conj
	_verb
	@@

# either noun verb
@CHECK
  # if noun is not a proper name...
  if (N("unknown",2))
    fail();
@POST
  group(1,1,"_det");
  group(1,2,"_np");
@RULES
_xNIL <-
	either [s]
	_noun
	_xWILD [s one lookahead match=(_vg _verb)]
	@@

# "to increased"
# "to increasing" -- don't know.
@POST
  S("text") = strtolower(N("$text",2));
  S("tmp") = N(2);
  if (N("verb",2))
    {
    if (N("-en",2) || N("-edn",2)
      || strendswith(S("text"),"ed") )
	   {
       group(2,2,"_adj");
       pncopyvars(S("tmp"),N(2));
	   N("id",2) = "compo1 01";
	   }
	else if (!suffix(S("text"),"s")
	 && !strendswith(S("text"),"ing") )
	   {
	   group(2,2,"_verb");
	   group(2,2,"_vg");
	   pncopyvars(S("tmp"),N(2));
	   N("id",2) = "compo1 01";
	   }
    }
  else if (N("noun",2) && suffix(S("text"),"s"))
    {
    group(2,2,"_noun");
	group(2,2,"_np");
	pncopyvars(S("tmp"),N(2));
	   N("id",2) = "compo1 01";
	}
@RULES
_xNIL <-
	to [s]
	_xALPHA
	@@

@CHECK
  if (N("-en",2) || N("-edn",2))
  	succeed();
  S("text") = strtolower(N("$text",2));
  if (strendswith(S("text"),"ed"))
  	succeed();
  fail();
@POST
  pnrename(N(2),"_adj");
  N("id",2) = "compo1 01";	# for tracing.
@RULES
_xNIL <-
	to [s]
	_verb
	@@

#########################
######### MODAL #########
#########################

# Need "real" verb possibility plus agreement.
### MODAL HAVE BE BEING ALPHA
@CHECK
  if (!N("verb",9))
    fail();
  if (N(7) && !N(5))
    fail();
  G("tmp") = vgagree(N(1),N(3),N(5),N(7),N(9));
  if (!G("tmp")[0])
    fail();
  G("tmp") = strtolower(N("$text",9));
  if (suffix(G("tmp"),"s"))
     fail();
  # NEED AGREEMENT CHECK HERE.
@POST
  # Not counting double-negation.
  if (N("neg",1) || N("neg",2) || N("neg",3)
   || N("neg",4) || N("neg",5) || N("neg",6)
   || N("neg",7) || N("neg",8) || N("neg",9))
    S("neg") = 1;
  pncopyvars(9);	# Promote verb's semantics.

  # Get passive voice.
  if (N(5))
    {
    G("be") = 1;
    G("verb") = N(9); # Arg to fn.
    G("passive") = 0; # Clear this.
    setpassive();
    if (G("passive"))
       S("passive") = G("passive"); # Result from fn.
	}
  
  # TODO: Get other modalities.

  single();
@RULES
_vg <-
	_modal [s]
	_xWILD [s star match=(_adv _advl)]
	_have [s opt]
	_xWILD [s star match=(_adv _advl)]
	_be [s opt]
	_xWILD [s star match=(_adv _advl)]
	being [s opt]
	_xWILD [s star match=(_adv _advl)]
	_xALPHA
	@@

# Note: Things like "John has eaten food." may be truly
# ambiguous.  Could retain e.g., "eaten" as a _seg, to
# defer resolution till there's enough evidence.
#### MODAL HAVE BE VERB
@CHECK
# First use of agreement function...
  G("tmp") = vgagree(N(1),N(3),N(5),N(7),N(9));
  if (!G("tmp")[0])
    fail();
@POST
  # Not counting double-negation.
  if (N("neg",1) || N("neg",2) || N("neg",3)
   || N("neg",4) || N("neg",5) || N("neg",6)
   || N("neg",7) || N("neg",8) || N("neg",9))
    S("neg") = 1;
  if (N(9))
    pncopyvars(9);	# Promote verb's semantics.
  else if (N(7))
	pncopyvars(7);
  else if (N(5))
    pncopyvars(5);
  else if (N(3))
    pncopyvars(3);
  else
    pncopyvars(1);

  # Get passive voice.
  if (N(5) && N(9))
    {
    G("be") = 1;
    G("verb") = N(9); # Arg to fn.
    G("passive") = 0; # Clear this.
    setpassive();
    if (G("passive"))
       S("passive") = G("passive"); # Result from fn.
	}
  
  # TODO: Get other modalities.

  single();
@RULES
_vg <-
	_modal [s]
	_xWILD [s star match=(_adv _advl)]
	_have [s opt]
	_xWILD [s star match=(_adv _advl)]
	_be [s opt]
	_xWILD [s star match=(_adv _advl)]
	being [s opt]
	_xWILD [s star match=(_adv _advl)]
	_verb [s opt]	# Now optional.	# 05/01/02 AM.
	@@


#########################
######### HAVE ##########
#########################

### HAVE BE BEING ALPHA
@CHECK
  if (!N("verb",7))
     fail();
  if (N(5) && !N(3))
  	fail();
  G("tmp") = strtolower(N("$text",7));
  if (suffix(G("tmp"),"s"))
     fail();
  # NEED AGREEMENT CHECK HERE.
  G("tmp1") = vgagree(0,N(1),N(3),N(5),N(7));
  if (!G("tmp1")[0])
    fail();
@POST
  # Not counting double-negation.
  if (N("neg",1) || N("neg",2) || N("neg",3)
   || N("neg",4) || N("neg",5) || N("neg",6)
   || N("neg",7))
    S("neg") = 1;
  pncopyvars(7);	# Promote verb's semantics.

  # Get passive voice.
  if (N(3))
    {
    G("be") = 1;
    G("verb") = N(7); # Arg to fn.
    G("passive") = 0; # Clear this.
    setpassive();
    if (G("passive"))
       S("passive") = G("passive"); # Result from fn.
	}
  
  # TODO: Get other modalities.

  single();
@RULES
_vg <-
	_have [s]
	_xWILD [s star match=(_adv _advl)]
	_be [s opt]
	_xWILD [s star match=(_adv _advl)]
	being [s opt]
	_xWILD [s star match=(_adv _advl)]
	_xALPHA
	@@

#### HAVE BE VERB
@CHECK
  if (N(5) && !N(3))
  	fail();
@POST
  # Not counting double-negation.
  if (N("neg",1) || N("neg",2) || N("neg",3)
   || N("neg",4) || N("neg",5) || N("neg",6)
   || N("neg",7))
    S("neg") = 1;
  if (N(7))
    pncopyvars(7);	# Promote verb's semantics.
  else if (N(5))
    pncopyvars(5);
  else if (N(3))
    pncopyvars(3);
  else
    pncopyvars(1);

  # Get passive voice.
  if (N(3) && N(7))
    {
    G("be") = 1;
    G("verb") = N(7); # Arg to fn.
    G("passive") = 0; # Clear this.
    setpassive();
    if (G("passive"))
      S("passive") = G("passive"); # Result from fn.
	}
  
  # TODO: Get other modalities.

  single();
@RULES
_vg <-
	_have [s]
	_xWILD [s star match=(_adv _advl)]
	_be [s opt]
	_xWILD [s star match=(_adv _advl)]
	being [s opt]
	_xWILD [s star match=(_adv _advl)]
	_verb [s opt]
	@@

#########################
#########  BE  ##########
#########################

### BE BEING ALPHA
@CHECK
  if (!N("verb",5))
     fail();
  G("tmp") = vgagree(0,0,N(1),N(3),N(5));
  if (!G("tmp")[0])
    fail();
@POST
  # Not counting double-negation.
  if (N("neg",1) || N("neg",2) || N("neg",3)
   || N("neg",4) || N("neg",5))
    S("neg") = 1;
  pncopyvars(5);	# Promote verb's semantics.

  # Get passive voice.
  G("be") = 1;
  G("verb") = N(5); # Arg to fn.
  G("passive") = 0; # Clear this.
  setpassive();
  if (G("passive"))
     S("passive") = G("passive"); # Result from fn.
  
  # TODO: Get other modalities.

  single();
@RULES
_vg <-
	_xWILD [s one match=(_be) except=(_vg)]
	_xWILD [s star match=(_adv _advl)]
	being [s opt]
	_xWILD [s star match=(_adv _advl)]
	_xALPHA
	@@


#### BE VERB
@POST
  # Not counting double-negation.
  if (N("neg",1) || N("neg",2) || N("neg",3)
   || N("neg",4) || N("neg",5))
    S("neg") = 1;
  if (N(5))
    pncopyvars(5);	# Promote verb's semantics.
  else if (N(3))
    pncopyvars(3);
  else
    pncopyvars(1);

  # Get passive voice.
  if (N(5))
    {
    G("be") = 1;
    G("verb") = N(5); # Arg to fn.
    G("passive") = 0; # Clear this.
    setpassive();
    if (G("passive"))
      S("passive") = G("passive"); # Result from fn.
    }
  
  # TODO: Get other modalities.
  if (N(5))
    single();
  else if (N(3))
    singler(1,3);	# 09/05/02 AM.
  else
    singler(1,1);	# 09/05/02 AM.
@RULES
# Exceptional modals....
_vg <-
	_be [s]
	_xWILD [s star match=(_adv _advl)]
	being [s opt]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(done)]
	@@

_vg <-
	_be [s]
	_xWILD [s star match=(_adv _advl)]
	being [s opt]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s opt match=(_verb) except=(_modal _have _be _vg)]
	@@


#########################
######### BEING #########
#########################

### BEING ALPHA
@CHECK
  if (!N("verb",3))
     fail();
  if (N("-edn",3) || N("-en",3))
    succeed();
  if (N("inf",3))
    fail();
  G("tmp") = strtolower(N("$text",3));
  if (strendswith(G("tmp"),"ed"))
	succeed();
  fail();
@POST
  # Not counting double-negation.
  if (N("neg",1) || N("neg",2) || N("neg",3))
    S("neg") = 1;
  pncopyvars(3);	# Promote verb's semantics.

  # Get passive voice.
  G("be") = 1;
  G("verb") = N(3); # Arg to fn.
  G("passive") = 0; # Clear this.
  setpassive();
  if (G("passive"))
     S("passive") = G("passive"); # Result from fn.
  
  # TODO: Get other modalities.

  single();
@RULES
_vg <-
	being [s]
	_xWILD [s star match=(_adv _advl)]
	_xALPHA
	@@


#### BEING VERB
@CHECK
# If verb, must be passive.
  if (N(3))
    {
	if (N("-edn",3) || N("-en",3))
      succeed();
	if (N("inf",3))
	  fail();
	G("tmp") = strtolower(N("$text",3));
	if (strendswith(G("tmp"),"ed"))
	  succeed();
	fail();
	}
@POST
  # Not counting double-negation.
  if (N("neg",1) || N("neg",2) || N("neg",3))
    S("neg") = 1;
  if (N(3))
    pncopyvars(3);	# Promote verb's semantics.
  else
    pncopyvars(1);

  if (N(3))
    S("passive") = 1;
  single();
@RULES
_vg <-
	being [s]
	_xWILD [s star match=(_adv _advl)]
	_verb [s opt]
	@@


#########################
######### VERB ##########
#########################

@CHECK
  if (!N("-ed",1))
  	fail();
  if (!N("verb",2))
  	fail();
  G("tmp") = strtolower(N("$text",2));
  if (!strendswith(G("tmp"),"ing"))
  	fail();
@POST
  group(2,2,"_verb");
  single();
@RULES
_vg <-
	_verb
	_xALPHA
	@@

@CHECK
  if (!N("-ed"))
    fail();
  if (N("sem") == "be")
    fail();
@RULES
_vg <- _verb @@


# Lone verb.  (Will usually participate in segmentation.)
@CHECK
  S("text") = strtolower(N("$text",1));
  if (strendswith(S("text"),"ing")
   || strendswith(S("text"),"ed")
   || N("-edn",1) )
    fail();
@POST
  singler(1,1);
@RULES
_vg <-
	_xWILD [s one match=(_verb) except=(_vg _modal _have _be)]
	_xWILD [s one lookahead match=(_noun)]
	@@

## Miscellaneous.

# "this precludes eating..."
# Need singular/plural agreement checks.
@CHECK
  S("vconj") = vconj(N(2));
  if (S("vconj") != "-s"
   && S("vconj") != "-edn"
   && S("vconj") != "-ed")
    fail();
@POST
  S("tmp") = strtolower(N("$text",1));
  if (S("tmp") == "this")
    {
	S("tmp1") = N(1);
	group(1,1,"_noun");
	group(1,1,"_np");
	pncopyvars(S("tmp1"),N(1));
	}
  group(2,2,"_vg");
  N("id",2) = "compo1 02";
@RULES
_xNIL <-
	_xWILD [s one match=(this that)]
	_verb
	@@

#########################
######### ALPHA #########
#########################

@CHECK
  if (!N("verb",2))
  	fail();
  # Need agreement checks.
  S("text") = strtolower(N("$text",2));
  if (strendswith(S("text"),"ing")
   || N("-en",2) )
   fail();
@POST
  S("tmp") = N(2);
  group(2,2,"_verb");
  group(2,2,"_vg");
  pncopyvars(S("tmp"),N(2));
  N("id",2) = "compo1 03";
@RULES
_xNIL <-
	_xWILD [s one match=(_pro)]
	_xALPHA
	_xWILD [s one lookahead match=(_adj)]
	@@

#########
## OTHER STUFF

@RULES
_adj <-
	_adj
	\(
	_xWILD [s star match=(but though yet _conj)]
	_xWILD [s star match=(_adv _advl)]
	_adj
	\)
	@@

