###############################################
# FILE: date.pat
# SUBJ: comment here
# AUTH: Your Name Here
# CREATED: 09/Nov/01 16:31:54
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par

# 0900 GMT
@POST
  single();
@RULES
_date [layer=(_noun _np)] <-
	_xNUM
	_xWILD [star match=(_xWHITE _nbsp)]
	_xWILD [one match=(GMT PST MST CST EST)]
	@@

@POST
  S("temporal") = 1;
  S("dy") = num(N("$text",3));
  S("mo") = num(N("$text",1));
  S("yr") = num(N("$text",5));
  # Normalize year.
  if (S("yr") < 20)
    S("yr") = S("yr") + 2000;
  else if (S("yr") < 100)
    S("yr") = S("yr") + 1900;
  single();
@RULES
_date [layer=(_noun _np)] <- 
    _xNUM [s]	### (1)
    \/ [s]		### (2)
    _xNUM [s]	### (3)
    \/ [s]		### (4)
    _xNUM [s]	### (5)
    @@

@CHECK
	S("dy") = num(N("$text",4));
	S("yr") = num(N("$text",7));
	if (S("dy") > 31)
		fail();
	if (S("yr") < 100)
		fail();
@POST
  S("mo") = monthtonum(strtolower(N("$text",1)));
  single();
@RULES
_date [layer=(_noun _np)] <-
	_xWILD [s one match=(
	January February March April May June July August
	September October November December
	
	Jan Feb Mar Apr May June Jul Aug Sep Sept Oct Nov Dec
		)]
	\. [s opt]
	_xWHITE [s star]
	_xNUM [s]
	\, [s opt]
	_xWHITE [s star]
	_xNUM [s]
	@@

# num month num
@CHECK
	S("dy") = num(N("$text",1));
	if (S("dy") > 31)
		fail();
	if (N(7))
	  {
	  S("yr") = num(N("$text",7));
	  if (S("yr") < 90
	   || (S("yr") > 99 && S("yr") < 1900)
	   || S("yr") > 2050)
	   fail();
	  }
@POST
  S("mo") = monthtonum(strtolower(N("$text",3)));
  if (N(7))
    S("don't splice") = 1;	# Keep this np.
  	# (Don't want to lose useful work.)
  single();
@RULES
_date [layer=(_noun _np)] <-
	_xNUM [s]
	_xWHITE [s star]
	_xWILD [s one match=(
	January February March April May June July August
	September October November December
	
	Jan Feb Mar Apr May June Jul Aug Sep Sept Oct Nov Dec
		)]
	\. [s opt]
	\, [s opt]
	_xWHITE [s star]
	_xNUM [s opt]
	@@

@CHECK
	S("dy") = 0;
	S("mooryr") = num(N("$text",5));
	if (S("mooryr") >= 1900)
	  S("yr") = S("mooryr");
	else if (S("mooryr") >= 90 && S("mooryr") <= 99)
	  S("yr") = 1900 + S("mooryr");
	else if (S("mooryr") <= 31)
	  S("dy") = S("mooryr");
	else
	  fail();
@POST
  S("mo") = monthtonum(strtolower(N("$text",1)));
  single();
@RULES
_date [layer=(_noun _np)] <-
	_xWILD [s one match=(
	January February March April May June July August
	September October November December
	
	Jan Feb Mar Apr May June Jul Aug Sep Sept Oct Nov Dec
		)]
	\. [s opt]
	\, [s opt]
	_xWHITE [s star]
	_xNUM [s]
	@@

@POST
  S("dy") = strtolower(N("$text"));
  S("sem") = "date";
  single();
@RULES
_date [layer=(_noun)] <- _xWILD [s one match=(
	Sunday Monday Tuesday Wednesday Thursday Friday Saturday
	)] @@

@POST
  S("hr") = num(N("$text",1));
  S("min") = num(N("$text",3));
  if (N(5))
    S("am/pm") = N("$text",5);
  single();
@RULES
_daytime [layer=(_noun _np)] <-
	_xNUM [s]
	\: [s]
	_xNUM [s]
	_xWHITE [s star]
	_xWILD [s opt match=(AM PM)]
	@@

# Put some semantics on.
@POST
  N("sem") = "date";
@RULES
_xNIL <- _xWILD [s one match=(
	millennium century decade year month week day
	evening night morning noon afternoon
	hour minute second
	today yesterday tomorrow
	)]
	@@
