###############################################
# FILE: l_clausal100.pat
# SUBJ: Form-fit clausal phrases prior to segmentation.
# AUTH: AM
# CREATED: 02/May/02 10:01:14
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@NODES _LINE

# Heur: Look for inflected verb in a blob.
# Heur: One main use of this pass will be to find "right
# boundaries" of noun phrases prior to the cruder segmentation
# processes.

# Noun phrases with a definite start.

@CHECK
  if (N(4))
  	{
	if (!N("noun",4) && !N("adj",4) && !N("unknown",4))
	  fail();
	if (!N("noun",3) && !N("adj",3) && !N("unknown",3))
	  fail();
	}
  else if (N(3))
  	{
	if (!N("noun",3) && !N("adj",3) && !N("unknown",3))
	  fail();
	}
@POST
  singler(1,4);
@RULES
_np <-
	_xWILD [s one match=(_det) except=(_fnword)]
	_xALPHA
	_xALPHA [opt]
	_xALPHA [opt]
	_verb [lookahead]
	@@

# ving noun of
@CHECK
	if (!N("verb",1))
		fail();
	S("text") = strtolower(N("$text",1));
	if (!strendswith(S("text"),"ing"))
		fail();
@POST
  group(1,1,"_verb");
@RULES
_xNIL <-
	_xALPHA
	_noun [lookahead]
	_xWILD [s one match=(of)]
	@@

# the prep
# det prep
@POST
  splice(2,2);
@RULES
_xNIL <-
	_xWILD [s one match=(the)]
	_prep
	_xWILD [s one lookahead match=(_xNUM _num _quan _adv _advl
		several few)]
	@@

# paren acronym
@RULES
_advl [layer=_acro] <-
	\( [s]
	_xALPHA
	\) [s]
	@@
