###############################################
# FILE: l_compo1.pat
# SUBJ: comment here
# AUTH: AM
# CREATED: 15/Apr/02 16:05:05
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@NODES _LINE

# Glom date stuff together.
@POST
  ++S("don't splice");
  single();
@RULES
_date [layer=(_np)] <-
	_date [s plus]
	\, [opt]
	_date [s plus]
	@@

# "to increased"
# "to increasing" -- don't know.
@POST
  S("text") = strtolower(N("$text",2));
  S("tmp") = N(2);
  if (N("verb",2))
    {
    if (N("-en",2) || N("-edn",2)
      || strendswith(S("text"),"ed") )
	   {
       group(2,2,"_adj");
       pncopyvars(S("tmp"),N(2));
	   }
	else if (!suffix(S("text"),"s")
	 && !strendswith(S("text"),"ing") )
	   {
	   group(2,2,"_verb");
	   group(2,2,"_vg");
	   pncopyvars(S("tmp"),N(2));
	   }
    }
  else if (N("noun",2) && suffix(S("text"),"s"))
    {
    group(2,2,"_noun");
	group(2,2,"_np");
	pncopyvars(S("tmp"),N(2));
	}
@RULES
_xNIL <-
	to [s]
	_xALPHA
	@@

@CHECK
  if (N("-en",2) || N("-edn",2))
  	succeed();
  S("text") = strtolower(N("$text",2));
  if (strendswith(S("text"),"ed"))
  	succeed();
  fail();
@POST
  pnrename(N(2),"_adj");
@RULES
_xNIL <-
	to [s]
	_verb
	@@

#########################
######### MODAL #########
#########################

# Note: Things like "John has eaten food." may be truly
# ambiguous.  Could retain e.g., "eaten" as a _seg, to
# defer resolution till there's enough evidence.
#### MODAL HAVE BE VERB
@CHECK
# First use of agreement function...
  G("tmp") = vgagree(N(1),N(3),N(5),N(7),N(9));
  if (!G("tmp")[0])
    fail();
@POST
  # Not counting double-negation.
  if (N("neg",1) || N("neg",2) || N("neg",3)
   || N("neg",4) || N("neg",5) || N("neg",6)
   || N("neg",7) || N("neg",8) || N("neg",9))
    S("neg") = 1;
  if (N(9))
    pncopyvars(9);	# Promote verb's semantics.
  else if (N(7))
	pncopyvars(7);
  else if (N(5))
    pncopyvars(5);
  else if (N(3))
    pncopyvars(3);
  else
    pncopyvars(1);

  # Get passive voice.
  if (N(5) && N(9))
    {
    G("be") = 1;
    G("verb") = N(9); # Arg to fn.
    G("passive") = 0; # Clear this.
    setpassive();
    if (G("passive"))
       S("passive") = G("passive"); # Result from fn.
	}
  
  # TODO: Get other modalities.

  single();
@RULES
_vg <-
	_modal [s]
	_xWILD [s star match=(_adv _advl)]
	_have [s opt]
	_xWILD [s star match=(_adv _advl)]
	_be [s opt]
	_xWILD [s star match=(_adv _advl)]
	being [s opt]
	_xWILD [s star match=(_adv _advl)]
	_verb [s]
	@@


#########################
######### HAVE ##########
#########################

#### HAVE BE VERB
@CHECK
  if (N(5) && !N(3))
  	fail();
@POST
  # Not counting double-negation.
  if (N("neg",1) || N("neg",2) || N("neg",3)
   || N("neg",4) || N("neg",5) || N("neg",6)
   || N("neg",7))
    S("neg") = 1;
  if (N(7))
    pncopyvars(7);	# Promote verb's semantics.
  else if (N(5))
    pncopyvars(5);
  else if (N(3))
    pncopyvars(3);
  else
    pncopyvars(1);

  # Get passive voice.
  if (N(3) && N(7))
    {
    G("be") = 1;
    G("verb") = N(7); # Arg to fn.
    G("passive") = 0; # Clear this.
    setpassive();
    if (G("passive"))
      S("passive") = G("passive"); # Result from fn.
	}
  
  # TODO: Get other modalities.

  single();
@RULES
_vg <-
	_have [s]
	_xWILD [s star match=(_adv _advl)]
	_be [s opt]
	_xWILD [s star match=(_adv _advl)]
	being [s opt]
	_xWILD [s star match=(_adv _advl)]
	_verb [s opt]
	@@

#########################
#########  BE  ##########
#########################

#### BE VERB
@POST
  # Not counting double-negation.
  if (N("neg",1) || N("neg",2) || N("neg",3)
   || N("neg",4) || N("neg",5))
    S("neg") = 1;
  if (N(5))
    pncopyvars(5);	# Promote verb's semantics.
  else if (N(3))
    pncopyvars(3);
  else
    pncopyvars(1);

  # Get passive voice.
  if (N(5))
    {
    G("be") = 1;
    G("verb") = N(5); # Arg to fn.
    G("passive") = 0; # Clear this.
    setpassive();
    if (G("passive"))
      S("passive") = G("passive"); # Result from fn.
    }
  
  # TODO: Get other modalities.
  if (N(5))
    single();
  else if (N(3))
    singler(1,3);	# 09/05/02 AM.
  else
    singler(1,1);	# 09/05/02 AM.
@RULES
_vg <-
	_be [s]
	_xWILD [s star match=(_adv _advl)]
	being [s opt]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s opt match=(_verb) except=(_modal _have _be _vg)]
	@@


#########################
######### BEING #########
#########################

#### BEING VERB
@CHECK
# If verb, must be passive.
  if (N(3))
    {
	if (N("-edn",3) || N("-en",3))
      succeed();
	if (N("inf",3))
	  fail();
	G("tmp") = strtolower(N("$text",3));
	if (strendswith(G("tmp"),"ed"))
	  succeed();
	fail();
	}
@POST
  # Not counting double-negation.
  if (N("neg",1) || N("neg",2) || N("neg",3))
    S("neg") = 1;
  if (N(3))
    pncopyvars(3);	# Promote verb's semantics.
  else
    pncopyvars(1);

  if (N(3))
    S("passive") = 1;
  single();
@RULES
_vg <-
	being [s]
	_xWILD [s star match=(_adv _advl)]
	_verb [s opt]
	@@


# Just for highlighting!!
@POST
  noop();
@RULES
_xNIL <- _xWILD [s one match=(
	_modal _have _be _verb
	)] @@

@CHECK
  if (!N("verb"))
    fail();
@POST
  noop();
@RULES
_xNIL <- _xALPHA @@


# "the storage of WASTE in..."
@CHECK
  if (!N("noun",2))
  	fail();
  if (N("adv",2))
  	fail();
  S("text") = strtolower(N("$text",2));
  if (strendswith(S("text"),"ing"))
  	fail();
@POST
  S("tmp") = N(2);
  group(2,2,"_noun");
  pncopyvars(S("tmp"),N(2));
@RULES
_xNIL <-
	of [s]
	_xALPHA [s]
	@@

# "while asking"
# A weak rule.
@CHECK
  if (!N("verb",2))
  	fail();
  S("text") = strtolower(N("$text",2));
  if (!strendswith(S("text"),"ing"))
  	fail();
@POST
  group(2,2,"_verb");
  group(2,2,"_vg");
@RULES
_xNIL <-
	_xWILD [s one match=(while when)]
	_xALPHA
	@@

# to _verb
@POST
  group(2,2,"_vg");
@RULES
_xNIL <-
	to [s]
	_xWILD [s one match=(_verb) except=(_vg _modal _have _be)]
	@@

# Variant for line-oriented, so it will be undone.
# May want a flag for splicing.
@RULES
_np <-
	_xWILD [s one match=(usd)]
	_xWILD [s plus match=(_xNUM _num _quan)]
	_xEND
	@@

@RULES
_noun <-
	_xWILD [s one match=(usd)]
	_xWILD [s plus match=(_xNUM _num _quan)]
	@@


#########################
######### VERB ##########
#########################

@CHECK
  if (!N("-ed",1))
  	fail();
  if (!N("verb",2))
  	fail();
  G("tmp") = strtolower(N("$text",2));
  if (!strendswith(G("tmp"),"ing"))
  	fail();
@POST
  group(2,2,"_verb");
  single();
@RULES
_vg <-
	_verb
	_xALPHA
	@@

@CHECK
  if (!N("-ed"))
    fail();
  if (N("sem") == "be")	# BUG FIX.	# 07/15/02 AM.
    fail();
@RULES
_vg <- _verb @@


#########################
######### ALPHA #########
#########################

@CHECK
  if (!N("verb",2))
  	fail();
  # Need agreement checks.
  S("text") = strtolower(N("$text",2));
  if (strendswith(S("text"),"ing")
   || N("-en",2) )
   fail();
@POST
  S("tmp") = N(2);
  group(2,2,"_verb");
  group(2,2,"_vg");
  pncopyvars(S("tmp"),N(2));
@RULES
_xNIL <-
	_xWILD [s one match=(_pro)]
	_xALPHA
	_xWILD [s one lookahead match=(_adj)]
	@@
