###############################################
# FILE: l_fnretok.pat
# SUBJ: Function word retokenization.
# AUTH: AM
# CREATED: 13/Apr/02 22:45:37
# NOTE:	Mirrors fn_retok but in different context.
###############################################

@CODE
if (!G("zoning"))
  exitpass();
@@CODE

@NODES _LINE

@POST
  S("neg") = 1;
  single();
@RULES

_modal <- won \' t @@
_modal <- wouldn \' t @@
_modal <- can \' t @@
_modal <- cannot @@
_modal <- couldn \' t @@
_modal <- mayn \' t @@
_modal <- mightn \' t @@
_modal <- shan \' t @@
_modal <- shouldn \' t @@
_modal <- oughtn \' t @@
_modal <- mustn \' t @@
_modal <- don \' t @@
_modal <- doesn \' t @@
_modal <- didn \' t @@

_have [layer=(_verb)] <- haven \' t @@
_have [layer=(_verb)] <- hasn \' t @@
_have [layer=(_verb)] <- hadn \' t @@

_be [layer=(_verb)] <- wasn \' t @@
_be [layer=(_verb)] <- weren \' t @@
_be [layer=(_verb)] <- aren \' t @@
_be [layer=(_verb)] <- isn \' t @@

@POST
  group(1,1, "_proSubj");
  group(1,1, "_pro");
  group(2,3, "am");	# Retokenize.
@RULES
_xNIL <-
  I [s]
  \' [s]
  m [s]
  @@

@RULES
_num <-
	_xNUM
	\' [s]
	s [s]
	@@

@RULES
_aposS <-
	\' [s]
	s [s]
	@@

# alpha '
@POST
  N("apostrophe",1) = 1;
  excise(2,2);	# Trash the apostrophe.
@RULES
_xNIL <-
	_xALPHA [s]
	\' [trigger]
	@@


# Some mumbles.
@POST
  ++X("nmumbles");
  single();
@RULES
_mumble <-
	_xWILD [min=2 match=(_xALPHA _xNUM \_ )]
	@@

_mumble <-
	_xALPHA
	_xNUM
	@@

_noun <-
	_noun
	\/
	_noun
	@@

@RULES
_dbldash <- \- \- \- @@  # Triple!
_dbldash <- \- \- @@

@POST
  group(2,2,"_dbldash");
@RULES
_xNIL <-
	_xWHITE [s plus]
	\-
	_xWHITE [s plus]
	@@
