###############################################
# FILE: l_lexunambig.pat
# SUBJ: comment here
# AUTH: AM
# CREATED: 15/Apr/02 14:36:11
# MODIFIED:
###############################################

@CODE
G("pos") = 0;
@@CODE

@NODES _LINE

@PRE
<1,1> length(1);
@POST
  noop();
@RULES
_xNIL <-
	_xALPHA
	\. [s]
	@@

# Special cases...
# directly is almost always an adv, not a conj.
@RULES
_adv <- directly @@

@POST
  if (!N("noun",2)
   && !N("adj",2)
   && !N("adv",2)
   && N("verb",2) )
    {
	++N("pos num",2);
	N("ADDED POS") = 1;
	N("adj") = 1;
	"pos.txt" << "added adj to '" << N("$text",2) << "'\n";
	}
@RULES
_xNIL <-
	the [s]
	_xALPHA
	@@

@POST
  singler(1,1);
@RULES
_np <-
	_xWILD [s one match=(both) except=(_np)]
	of [s lookahead]
	@@

@POST
  S("tmp") = N(2);
  group(2,2,"_prep");
  pncopyvars(S("tmp"),N(2));
@RULES
_xNIL <-
	\, [s]
	_xWILD [s one match=(including)]
	@@

@POST
  group(1,1,"_pro");
  group(1,1,"_np");
@RULES
_xNIL <-
	one [s lookahead]
	_prep [s]
	@@

@POST
  group(1,1,"_verb");
@RULES
_xNIL <-
	need
	to
	_be [s]
	@@


# tons a year => tons per year
# a => per, an => per
@POST
  group(2,2,"per");
  group(2,2,"_prep");
  setbase(2,"true");
@RULES
_xNIL <-
	_xALPHA
	_xWILD [s one match=(a an)]
	_xWILD [s one match=(
		year day month
		hour minute second
		)]
	@@

@CHECK
  if (!N("noun",2))
    fail();
@POST
  S("tmp") = N(2);
  group(2,2,"_noun");
  pncopyvars(S("tmp"),N(2));
@RULES
_xNIL <-
	this [s]
	_xALPHA
	@@

# More NUMBER NUMERIC processing here.
# "more than 5 million".
@RULES
_num <-
	_xWILD [s one match=(more less)]
	than [s]
	_xNUM [s]
	_num [s]
	@@

_num <-
	_xWILD [s one match=(_xNUM _num)]
	to [s]
	_xWILD [s one match=(_xNUM _num)]
	@@

_num <-
	_xWILD [s one match=(_xNUM _num)]
	\-
	_xWILD [s one match=(_xNUM _num)]
	@@

_num <-
	_xNUM
	_conj
	_xNUM
	@@

@POST
  pncopyvars(2);
  if (N("adj sem",2))
    S("sem") = N("adj sem",2);
  else if (!N("sem",2))
    {
	S("tmp") = strtolower(N("$text",2));
    S("stem") = stem(S("tmp"));
    if (S("stem"))
       S("sem") = S("stem");
    else
       S("sem") = S("tmp");
    }
  single();
@RULES
_adj <-
  _premod [s]
  _xALPHA
  @@
  
# idiom.
@RULES
_conj <-
	\, [s opt]
	that [s]
	is [s]
	to [s]
	say [s]
	\, [s opt]
	@@

@CHECK
  if (!N("adj",1) && !N("noun",1))
    fail();
  if (N("adv",1))
    fail();
@POST
  S("tmp") = N(1);
  if (N("noun",1))
    group(1,1,"_noun");
  else if (N("adj",1))
    group(1,1,"_adj");
  pncopyvars(S("tmp"),N(1));
@RULES
_xNIL <-
	_xALPHA
	_xWILD [s one lookahead match=(_modal _have _be)]
	@@
  
@POST
	if (N("pos num") == 1)	# UNAMBIGUOUS PART OF SPEECH.
		{
		if (N("pos"))
		   {
		   G("node") = N(1);
		   group(1,1,N("pos"));
		   pncopyvars(G("node"),N(1));	# 12/14/01 AM.
		   if (!N("sem"))	# 01/01/02 AM.
		     {
			 if (N("text"))
			   S("tmp") = N("text");
			 else
			   S("tmp") = strtolower(N("$text"));
		     S("stem") = stem(S("tmp"));
		     if (S("stem"))
		        N("sem") = S("stem");
		     else
		        N("sem") = S("tmp");
			 }
		   }
		}
	# STARTING TO USE CONFIDENCE, FREQUENCY.	# 06/02/02 AM.
	else if (N("verb") >= 90)
	  {
      S("tmp") = N(1);
      group(1,1,"_verb");
      pncopyvars(S("tmp"),N(1));
	  }
	else if (N("adv") >= 90)
	  {
      S("tmp") = N(1);
      group(1,1,"_adv");
      pncopyvars(S("tmp"),N(1));
	  }


@RULES
_xNIL <-
	_xALPHA	# Uncharacterized, unreduced.
	@@

# Retokenized stuff.
@CHECK
  if (!pndown(N(1)))
  	fail();
  if (strchr(pnname(N(1)),"_")) # Lame nonliteral test.
    fail();
@POST
	if (N("pos num") == 1)	# UNAMBIGUOUS PART OF SPEECH.
		{
		if (N("pos"))
		   {
		   G("node") = N(1);
		   group(1,1,N("pos"));
		   pncopyvars(G("node"),N(1));	# 12/14/01 AM.
		   if (!N("sem"))	# 01/01/02 AM.
		     {
			 if (N("text"))
			   S("tmp") = N("text");
			 else
			   S("tmp") = strtolower(N("$text"));
		     S("stem") = stem(S("tmp"));
		     if (S("stem"))
		        N("sem") = S("stem");
		     else
		        N("sem") = S("tmp");
			 }
		   }
		}
@RULES
_xNIL <-
	_xANY
	@@

