###############################################
# FILE: np_list100.pat
# SUBJ: comment here
# AUTH: AM
# CREATED: 26/Apr/02 15:18:23
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par

## Don't want sentence break in the middle of another scope.
## E.g., "(hello: bye)", don't want this to be
## "(hello:"  => sentence
## "bye)"  => start of next sentence.
@RULES
_scope <-
	\( [s]
	_xWILD
	\) [s]
	@@

# Hmm, this won't always be right.
# Need compatibility of nps to corroborate.
@CHECK
  if (N("sem",1) == "date"
   && (N("sem",3) != "date"
   || N("sem",5) != "date"))
    fail();
@RULES
_nps <-
	_np [s]
	\, [s]
	_np [s]
	\, [s opt]
	_conj [s]
	_np [s]
	@@


# "after heating and treatment with x"
@CHECK
  S("txt") = strtolower(N("$text",1));
  if (!strendswith(S("txt"),"ing"))
  	fail();
@RULES
_nps <-
	_vg [s]
	_conj [s]
	_np [s]
	@@

# Introducing more constrained instances...	# 09/21/02 AM.
@POST
  S("pn nps")[0] = N(2);
  S("pn nps")[1] = N(4);
  domcompose(N(2),N(4));
  singler(2,4);
@RULES
_nps <-
	_xWILD [s one match=(_vg)]
	_xWILD [s one match=(_np _nps)]
	_conj
	_xWILD [s one match=(_np _nps)]
	_xWILD [s one lookahead match=(\, _fnword)]
	@@


@RULES
_nps <-
	_np
	\/
	_np
	@@

@CHECK
  if (!N("seg nouns",5))
    fail();
@POST
  pnrename(N(5),"_np");
  singler(1,5);
@RULES
_nps <-
	_xWILD [s one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_conj [s]
	_xWILD [s star match=(_adv _advl)]
	_seg
	_xWILD [s one lookahead fail=(_np _nps)]
	@@

# [ .. ]
@POST
  S("square brackets") = 1;
  singlex(2,2);
@RULES
_advl <-
	\[ [s]
	_xWILD
	\] [s]
	@@

# several of np
@POST
  pncopyvars(3);
  single();
@RULES
_np <-
	several [s]
	of [s]
	_xWILD [s one match=(_np _nps)]
	@@

# np pro
# John himself
@POST
  listadd(1,2,"false");
@RULES
_xNIL <-
	_np
	_xWILD [s one match=(himself herself itself
		ourselves yourselves themselves)]
	@@
