###############################################
# FILE: phr_task10.pat
# SUBJ: Implementing a phrase counting task here.
# AUTH: AM
# CREATED: 27/Feb/02 12:03:16
# NOTE:	Method will be to traverse the entire tree, placing
#	phrases as strings into the KB dictionary area.
#	Will look for particular types of phrases, mainly np and vg
#	and alpha for now.
#	Will limit the alphabetic length.
#	Inside each phrase, traverse the subtree, counting alphas and
#	collecting an alpha string.
###############################################

@CODE
if (!G("TASK: Count Phrases Multi"))
  exitpass();
G("root") = findroot();
if (batchstart())	# First file in a batch.
  {
  G("phrases") = findconcept(G("root"),"phrases");
  if (G("phrases"))
    rmconcept(G("phrases"));
  }
G("phrases") = getconcept(G("root"), "phrases");
@@CODE

@PATH _ROOT _TEXTZONE _par _sentence

@CHECK
  if (N("counted"))	# If already recorded.
    fail();
@POST
  S("txt") = N("$text");	# Fetch node's text.
  
  # Fetch or add phrase to KB.
  S("phrase concept") = getconcept(G("phrases"), S("txt"));
  "phr.txt" << conceptname(S("phrase concept")) << "\n";
  
  # Update the count for current document.
  S("count") = numval(S("phrase concept"), "doc count");
  replaceval(S("phrase concept"),"doc count", ++S("count"));

  # Update the count for total batch.
  S("count") = numval(S("phrase concept"), "tot count");
  replaceval(S("phrase concept"),"tot count", ++S("count"));

  N("counted") = 1;	# Mark as recorded.
@RULES
_xNIL <- _xWILD [one match=(
	_np _vg
	_seg
	)] @@
