###############################################
# FILE: preclause.pat
# SUBJ: comment here
# AUTH: AM
# CREATED: 30/Apr/02 15:25:29
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par _sentence


# Looking at some helping verbs.
@CHECK
  if (!N("stem",1))
  	fail();
  if (N("stem",1) != "help")
  	fail();
@RULES
_vg <-
	_vg
	_vg
	@@

# vg date vg
# vg np vg
# vg np seg
# "have this week put ..."
@CHECK
  if (N("sem",2) != "date")
    fail();
  if (N("sem",1) != "have"
   && N("sem",1) != "be")
   # Need some test for modal...
   fail();
  S("tmp1") = pnname(N(3));
  if (S("tmp1") == "_seg"
   && !N("verb",3))
    fail();
  # NEED CHECK FOR AGREEMENT
@POST
  S("tmp") = N(2);
  group(2,2,"_advl");
  pncopyvars(S("tmp"),N(2));
  if (S("tmp1") == "_seg")
    pnrename(N(3),"_vg");	# Something like that...
  # Remake the verb group...
  # Dissolve the vgs underneath...
  pncopyvars(3);
  single();
@RULES
_vg <-
	_vg
	_np
	_xWILD [one match=(_vg _seg)]
	@@


# A bit of apposition
#@RULES
#_np <-
#	_xWILD [s one match=(_np _nps)]
#	\, [s]
#	_xWILD [s one match=(_np _nps)]
#	\, [s]
#	@@

# Some clausal patterns.
@POST
  if (N("noun",8) || N("seg nouns",8))
    pnrename(N(8),"_np");
@RULES
_xNIL <-
	_xSTART
	_xWILD [opt match=(_conj _fnword)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_seg
	@@

@POST
  if (N("noun",4) || N("seg nouns",4))
    pnrename(N(4),"_np");
@RULES
_xNIL <-
	_xSTART
	_xWILD [opt match=(_conj _fnword)]
	_xWILD [s star match=(_adv _advl)]
	_seg
	_xWILD [s star match=(_adv _advl)]
	_vg
	@@

# neither np
@POST
  if (!X("nor"))	# No "nor" in sentence.
    listadd(2,1,"false"); # Glom "neither" into np.
@RULES
_xNIL <-
	neither [s]
	_np
	@@

# (copula) adj than np
# no less than 3 beers...
@POST
  N("glom left",7) = 1;
  group(1,5,"_vg");
@RULES
_xNIL <-
	_vg [opt]
	_xWILD [s star match=(_adv _advl)]
	_adj [s]
	_xWILD [s star match=(_adv _advl)]
	than [s]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(_np _nps)]
	@@

# vg conj vg
@CHECK
  if (N(8))
    {
	if (N("glom left",5) || N("glom right",4))
	  fail();
	}
@POST
  singler(1,4);
@RULES
_vg <-
	_vg
#	_xWILD [s star match=(_adv _advl)]
#	\, [s opt]
#	_xWILD [s star match=(_adv _advl)]
	_conj
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [one lookahead match=(_xANY _xEND)]
	@@

# neither seg nor np
@POST
  pnrename(N(2),"_np");
  single();
@RULES
_np <-
	neither [s]
	_seg
	nor [s]
	_xWILD [s one match=(_np _nps)]
	@@

# vg seg np
@CHECK
  if (N("seg len",2) > 1)
    fail();
  if (!N("adv",2))
    fail();
@POST
  pnrename(N(2),"_adv");
@RULES
_xNIL <-
	_vg
	_seg
	_np
	@@


# all np
@POST
  N("premod",2) = "all";	# Some kind of quantifier flag.
  listadd(2,1,"false");
@RULES
_xNIL <-
	all [s]
	_xWILD [one match=(_np _nps)]
	@@

# turn left
# verb seg
@POST
  if (N("seg len",5) == 1)
    {
	if (N("adv",5))
	  pnrename(N(5),"_adv");
	else if (N("adj",5))
	  pnrename(N(5),"_adj");
	else if (N("noun",5))
	  pnrename(N(5),"_np");
	}
  else if (N("nouns",5))
    pnrename(N(5),"_np");
@RULES
_xNIL <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_seg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(_qEOS _xEND)]
	@@


# Should check for a locomotion verb. (semantics...)
# turn around
# verb prep
@CHECK
  if (N("no particle",3))
    fail();
@POST
  pnrename(N(5),"_adv");
  N("glom left",5) = 1;
  N("glom right",3) = 1;
@RULES
_xNIL <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(over around about down up)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(_qEOS _conj _xEND)]
	@@

@CHECK
  if (N("no particle",1))
    fail();
@POST
  pnrename(N(3),"_adv");
  N("glom left",3) = 1;
  N("glom right",1) = 1;
@RULES
_xNIL <-
	_vg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(over around about down up)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(_qEOS _conj _xEND)]
	@@

# Prepositional/phrasal verb.
@CHECK
  if (N("no particle",3))
    fail();
@POST
  pncopyvars(1);
  S("particle stem") = strtolower(N("$text",3));
  singler(1,3);
@RULES
_vg <-
	_vg
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(_prep) except=(until)]
	_xWILD [s one lookahead fail=(_det _quan _xNUM _num _adj _noun
		_np _seg both _vg)]
	@@

@POST
  S("pp") = 1;
  single();
@RULES
_advl <-
	_prep
	_np
	@@

# np vg vg
# eg, "the book eaten by worms fell apart ..."
# Checking if first vg is a subordinate clause candidate.
@CHECK
  S("verb") = N("first verb",5);
  if (!S("verb"))
    S("verb") = N(5);
  S("vc") = vconj(S("verb"));
  if (S("vc") != "-edn"
   && S("vc") != "-en")
    fail();
@POST
  S("tmp") = N(5);
  if (N("last verb",5))
    S("vb") = N("last verb",5);
  if (!S("vb"))
    S("vb") = N(5);
  nvn(0,N(3),0,N(5),N(6),0,0);
  group(5,6,"_clause");
  
  # Get values returned from nvnpassive.
  N("passive",5) = S("passive");
  N("actor",5) = S("actor");
  N("dobj",5) = S("dobj");
  N("act",5) = S("act");
  N("particle stem",5) = S("particle stem");
  N("adj stem",5) = S("adj stem");
  N("act val",5) = S("act val");
  N("act stem",5) = S("act stem");
  N("obj stem",5) = S("obj stem");

  if (pnvar(S("vb"),"sem"))
    N("sem",5) = pnvar(S("vb"),"sem");
  if (pnvar(S("vb"),"stem"))
    N("stem",5) = pnvar(S("vb"),"stem");
  S("tmp") = N(5);
  group(5,5,"_advl");
  pncopyvars(S("tmp"),N(5));
  N("subord",5) = 1;
@RULES
_xNIL <-
	_xSTART
	_xWILD [s star match=(_advl \, _adv)]
	_xWILD [one match=(_np _nps)]
	_xWILD [s star match=(_advl \, _adv)]
	_vg [s]
	_xWILD [s star match=(_advl \, _adv)]
	_vg [s lookahead]
	@@

# A catchall rule
@POST
  # Going to traverse the nps.  Todo: Would be best to have a
  # method for doing this in the @PRE region!
  # Collects in reverse.
  collectnps(N(2),lasteltnode(3));
  singler(2,3);
@RULES
_nps <-
	_xWILD [s one match=(_fnword)]
	_xWILD [s one match=(_np _nps)]
	_xWILD [s min=2 match=(_np _nps _conj \, _advl _adv)]
	_xWILD [s one lookahead match=(_fnword)]
	@@


# Looking for letter/email/e-mail style.
# name ,
# Could use capitalization cues also, check for known names, etc.
# Could see if same name has occurred elsewhere in text.
@CHECK
  if (!N("unknown",2))
    fail();
@POST
  ++G("letter style");	# Possible letter style.
  G("addressee") = strtolower(N("$text",2));
  "dump.txt" << "[Possible letter style, addressee="
  	<< N("$text",2) << "]\n";
#  S("addressee") = G("addressee");
  S("name") = pnname(N(2));
  S("tmp") = N(2);
  if (S("name") == "_seg")
    pnrename(N(2),"_np");
  N("addressee",2) = G("addressee");
@RULES
_xNIL <-
	_xSTART
	_xALPHA [s]
	\, [s lookahead]
	@@

# please seg np
# please help me
@CHECK
  if (!N("verb",2))
    fail();
@POST
  S("tmp") = N(2);
  pnrename(N(2),"_vg");
  pncopyvars(S("tmp"),N(2));
  N("id",2) = "prec 20";
@RULES
_xNIL <-
	please [s]
	_seg
	_xWILD [s one lookahead match=(_np _nps)]
	@@

# following an event.
# following => prep or fnword.
@POST
  S("tmp") = pnname(N(5));
  if (strchr(S("tmp"),"_"))
    pnrename(N(5),"_prep");
  else
    {
	S("tmp1") = N(5);
	group(5,5,"_prep");
	pncopyvars(S("tmp1"),N(5));
	}
  N("eventive",6) = 1;	# Designate as eventive.
  # (Should corroborate as possible eventive first...)
 
  S("tmp") = N(6);
  group(5,6,"_advl");
  pncopyvars(S("tmp"),N(5));
  N("clause",5) = S("tmp");	# 07/25/02 AM.
  N("pp",5) = 1;
  N("nps",5) = S("tmp");
@RULES
_xNIL <-
	_vg
	_xWILD [s star match=(_adv _advl)]
	_np [opt]
	_xWILD [s star match=(_adv _advl \,)]
	following [s]
	_xWILD [s one match=(_np _nps)]
	@@

# Parallel construction...
# np vg np conj np (vg) np
@POST
  nvn(0,N(6),0,N(3),0,N(7),0);
  singler(6,7);
@RULES
_clause <-
	_xWILD [s one match=( \, )]
	_np [s]
	_vg [s]
	_np [s]
	_conj [s]
	_np [s]
	_np [s]
	_xWILD [s one lookahead match=(_qEOS)]
	@@
