###############################################
# FILE: print_sem.pat
# SUBJ: Print out event-level output, etc.
# AUTH: AM
# CREATED: 25/Jun/02 13:58:39
# MODIFIED:
###############################################

@DECL

########
# FUNC:   PRINTEVENTS
# SUBJ:   Traverse and pretty print events in kb.
# CR:     07/11/02 AM.
# INPUT:  
# OUTPUT: 
########

printevents(L("events"))
{
G("out") << "\n";
G("out") << "EVENT OUTPUT" << "\n";
G("out") << "============" << "\n";

if (!L("events"))
  return;

# Traverse the events gathered for the text.
L("event") = down(L("events"));

while (L("event"))
  {
  G("count") = 0;	# Count values found.

  # Print out the current event as a record.
  # Todo: Get an "action concept" into event concept.
  L("txt") = strval(L("event"),"text");
  L("eventive text") = 0;
  if (L("txt"))
    {
    L("eventive text") = strtolower(L("txt"));
	++G("count");
	}
  
  L("act con") = conval(L("event"), "act");
  L("act text") = 0;
  if (L("act con"))
    {
	L("act text") = strval(L("act con"),"act val"); # 07/08/02 AM.
	if (!L("act text"))	# 07/08/02 AM.
	  L("act text") = strval(L("act con"),"sem");
	if (!L("act text"))
      L("act text") = strtolower(strval(L("act con"),"text"));
	if (L("act text") && numval(L("act con"),"negative"))
	  L("act text") = "not " + L("act text");
	}
  if (!L("act text") && L("eventive text"))
#    L("act text") = "experience";
	L("act text") = "<eventive np>";
  else if (L("act text"))
    ++G("count");

  L("actor text") = 0;
  L("actor con") = conval(L("event"),"actor");
  if (L("actor con"))
    {
    L("actor text") = strtolower(strval(L("actor con"),"text"));
	++G("count");
	}

  L("obj text") = 0;
  L("obj con") = conval(L("event"),"obj");
  if (L("obj con"))
    L("obj text") = strval(L("obj con"),"text");
  if (L("obj text"))
    {
    L("obj text") = strtolower(L("obj text"));
	++G("count");
	}

  L("iobj text") = 0;
  L("iobj con") = conval(L("event"),"iobj");
  if (L("iobj con"))
    L("iobj text") = strval(L("iobj con"),"text");
  if (L("iobj text"))
    {
    L("iobj text") = strtolower(L("iobj text"));
	++G("count");
	}

  L("state text") = 0;
  L("state con") = conval(L("event"),"state");
  if (L("state con"))
  	L("state text") = strval(L("state con"),"text");
  if (L("state text"))
    {
    L("state text") = strtolower(L("state text"));
	++G("count");
	}

  L("loc text") = 0;
  L("loc con") = conval(L("event"),"loc");
  if (L("loc con"))
    L("loc text") = strval(L("loc con"),"text");
  if (L("loc text"))
    {
    L("loc text") = strtolower(L("loc text"));
	++G("count");
	}

  # Criteria for minimal event to print out.
  if (L("act text") || G("count") >= 2)
    {
  # Print record out here.

  # Separate records with blank line.
  G("out") << "\n";

  G("out") << "id: \t" << conceptname(L("event")) << "\n";
  if (L("actor text"))
    {
    G("out") << "actor: \t"
     << L("actor text")
	 << " (" << conceptname(L("actor con")) << ")"
	 << "\n";
    }

  if (L("act text"))
    G("out") << "act: \t" << L("act text") << "\n";

  if (L("eventive text"))
    G("out") << "obj: \t" << L("eventive text")
		<< " (event)" << "\n";
  if (L("obj text") || L("obj con"))
    {
    G("out") << "obj: \t";
	if (L("obj text"))
     G("out") << L("obj text") << " ";
	if (L("obj con"))
	 G("out") << "(" << conceptname(L("obj con")) << ")";
	G("out") << "\n";
    }
  if (L("iobj text"))
    {
    G("out") << "iobj: \t"
     << L("iobj text")
	 << " (" << conceptname(L("iobj con")) << ")"
	 << "\n";
    }
  if (L("state text"))
    {
    G("out") << "state: \t"
     << L("state text")
	 << "\n";
	}
  if (L("loc text"))
    {
    G("out") << "loc: \t"
     << L("loc text")
	 << " (" << conceptname(L("loc con")) << ")"
	 << "\n";
    }

   } # End of if-minimal-event.

  # Get next event.
  L("event") = next(L("event"));
  }
}
@@DECL

@CODE
printevents(G("events"));
@@CODE
