###############################################
# FILE: qseg100.pat
# SUBJ: Characterize segments
# AUTH: AM
# CREATED: 15/May/02 12:47:03
# NOTE:	Part of this should be doable during segment
#	collection, with improvements to @pre region.
#	General assumption that segments are np-like, with possible
#	verbs and other junk in there.
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par _seg

# Some classic noun phrases.
@POST
  xrename("_np",4);
@RULES
_xNIL <-
	_xSTART
	_adj
	_noun
	_xEND
	@@


# Study first element of segment.
@POST
  ++X("seg len");
  X("det start") = 1;
  X("number") = N("number",2);  # singular/plural/any.
  if (N("neg",2))
    X("neg") = N("neg",2);
@RULES
_xNIL <-
	_xSTART
	_det [s]
	@@

@POST
  ++X("seg len");
  if (N("verb",2))
  	{
  	X("seg 1st verb") = 1;
	X("seg 1st vconj") = vconj(N(2));
	++X("seg verbs");	# Count verbs in seg.
	}
  if (N("noun",2))
    ++X("seg nouns");
  if (N("adj",2))
    ++X("seg adjs");
@RULES
_xNIL <-
	_xSTART
	_xANY
	@@

@POST
  X("aposs") = 1;
  X("aposs number") = number(N(1));
@RULES
_xNIL <-
  _xANY
  _aposS
  @@
 

# Study last element of segment.
@POST
  ++X("seg len");
  if (N("verb",1))
  	{
  	X("seg last verb") = 1;
	X("seg last vconj") = vconj(N(1));
	++X("seg verbs");	# Count verbs in seg.
	}
  if (N("noun",1))
    {
    ++X("seg nouns");
	X("seg last noun") = 1;
	}
  if (N("adj",1))
    {
	++X("seg adjs");
	X("seg last adj") = 1;
	}
  if (X("number") && X("number") != "any")
    {
    S("num") = number(N(1));
#	G("verbose") << N("$text",1) << " " << S("num") << "\n";
    if (S("num") != "any"
	 && S("num") != X("number")
	 && X("number") != X("aposs number")
	 && !N("mass",1)	# Not a mass/noncount noun.
	  )
	  # sing/plur disagreement.
	   X("seg last number disagree") = 1;
    }
@RULES
_xNIL <-
	_xANY
	_xEND
	@@

@POST
  ++X("seg len");	# Add to length of segment.
  if (N("verb",1))
	++X("seg verbs");	# Count verbs in seg.
  if (N("noun",1))
    ++X("seg nouns");
  if (N("adj",1))
    ++X("seg adjs");
@RULES
_xNIL <-
	_xANY
	@@
