###############################################
# FILE: retok.pat
# SUBJ: Re-tokenization.
# AUTH: AM
# CREATED: 10/Nov/01 11:42:08
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par

# Common abbrevs.
@RULES
_title [layer=(_noun)] <-
	_xWILD [s one match=(dr mr mrs jr sr)]
	\. [s]
	@@

_companyABBR [layer=(_noun _np)] <-
	_xWILD [s one match=(co corp inc ltd llp llc)]
	\. [s]
	@@

@RULES
_ie [layer=_fnword] <- i [s] \. [s] e [s] \. @@
_ie [layer=_fnword] <- ie \. @@

@POST
  singler(1,2);
@RULES
_abbrev [layer=(_noun)] <-
	_xALPHA
	\. [s]
	_xWILD [s one lookahead match=( \, )]
	@@

@RULES
_name [layer=(_noun)] <-
	O
	\'
	_xCAP
	@@

# More generally.
@PRE
<1,1> length(1);
<4,4> length(1);
@RULES
_abbrev [layer=(_noun)] <-
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	@@

# Grab abbreviations from dict.
@CHECK	# Fix. 02/07/03 AM.
  if (!N("abbr",1)
   && N("$length",1) != 1)	# Not letter.
    fail();
@RULES
_abbrev [layer=(_noun)] <-
	_xALPHA
	\. [s]
	@@

@RULES
and <- \& @@

@POST
  S("num") = num(N("$text",1));
  single();
@RULES
_num <- _xNUM _xWILD [s one match=( \+ \- )] @@

@RULES
_num <- \$ [s opt] _xNUM \. _xNUM @@


# Possible end of sentence markers.
@RULES
_qEOS <- _xWILD [one match=(
	\. \! \? \;
	\:	# 05/14/02 AM.
	)] @@



_noun <-
	_xALPHA
	\&
	_xALPHA
	@@

# Mumble mumble.
@RULES
_noun <-
	_xNUM
	\/
	_xALPHA
	@@

_noun <-
	_noun
	\/
	_noun
	@@

@POST
  singler(2,3);
@RULES
_noun <-
	_xWILD [s one match=(_xPUNCT _xWHITE)]
	_xNUM [s]
	_xALPHA [s]
	_xWILD [s one lookahead match=(_xPUNCT _xWHITE)]
	@@

@RULES
_noun <-
	_xALPHA
	\&
	_xALPHA
	@@

@POST
  if (N("verb",5))
	group(3,5,"_vg");
  else
    group(3,5,"_np");
@RULES
_xNIL <-
 _xWILD [s one match=(to)]
 _xWHITE [s star]
 _xALPHA
 \-
 _xALPHA
 @@

@RULES
_prep <-
	vis [s]
	\- [s]
	a [s]
	\- [s]
	vis [s]
	@@

@POST
  group(1,5,"_adj"); # Default.
@RULES
_xNIL <-
	_xALPHA
	\-
	_xALPHA
	\-
	_xALPHA
	@@

@POST
  if (N("noun",1) && N("noun",3))
  	group(1,3,"_noun");
  else if (N("unknown",1) || N("unknown",3))
  	group(1,3,"_noun");
  else if (N("adj",1) || N("adj",3))
  	group(1,3,"_adj");
  else if (N("verb",1) || N("verb",3))
    group(1,3,"_adj");
  else # Default
    group(1,3,"_noun");
@RULES
_xNIL <-
	_xALPHA
	\/
	_xALPHA
	@@

@POST
  N("quoted",2) = 1; # Flag that it is quoted.
  excise(3,3);
  excise(1,1);
@RULES
_xNIL <-
	\" [s]
	_xANY
	\" [s]
	@@

# Invert constructs like " ... xyz."
@POST
  group(2,2,"\.");	# Retok as period.
  group(2,2,"_qEOS");
  group(1,1,"\"");	# Retok as double quote.
@RULES
_xNIL <-
	_xWILD [one match=( \. \? \! \: )] # 05/14/02 AM.
	\"
	@@

# Some business stuff.
@RULES
_stockSYMBOL [layer=_advl] <-
	\( [s]
	_xALPHA [ren="_exchange"]
	\: [s]
	_xWHITE [s star]
	_xALPHA [ren="_ticker"]
	\) [s]
	@@

@POST
  S("noun") = 1;
  S("adj") = 1;
  S("sem") = "date";
  S("stem") = "o'clock";
  single();
@RULES
_oclock [layer=(_adj _noun)] <- o [s] \' clock @@
