###############################################
# FILE: seg25.pat
# SUBJ: Assure proper order for triggered seg rules.
# AUTH: AM
# CREATED: 19/May/02 19:09:00
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par _seg

# Dissolve last verb.
@CHECK
if (!X("seg split last verb"))
	fail();
@POST
  S("tmp") = N(3);
  group(3,3,"_verb");
  group(3,3,"_vg");
  pncopyvars(S("tmp"),N(3));
  L("x") = lasteltnode(2);
  group(2,2,"_np");
  pncopyvars(L("x"),N(2));
  X("dissolve") = 1;
@RULES
_xNIL <-
  _xSTART
  _xANY [plus]
  _xALPHA [trigger]
  _xEND
  @@

# Split because of number disagreement.
@CHECK
  if (!X("seg last number disagree"))
    fail();
  if (!X("seg last verb"))
    fail(); # At least, till we get full list of mass nouns.
@POST
  if (pnname(N(3)) != "_verb")
    group(3,3,"_verb");
  group(3,3,"_vg");
  group(2,2,"_np");
  X("dissolve") = 1;
@RULES
_xNIL <-
	_xSTART
	_xANY [plus]
	_xANY [trigger]
	_xEND
	@@
