###############################################
# FILE: sent100.pat
# SUBJ: Sentential, or multi-clause, handling.
# AUTH: AM
# CREATED: 24/May/02 14:42:42
# NOTE:	The domain-specific handling was for a "ballworld"
#	domain.  Need to generalize some of this.
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par _sentence

# Well-understood "if ... then ..." sentence.
@POST
  if (!X("text out"))
    {
    G("oldout") << "\n\n" << "TEXT: " << X("$raw") << "\n";
    X("text out") = 1;
	}
  domifthen(N(3),N(5));
  noop();
@RULES
_xNIL <-
	_xSTART
	if [s]
	_xWILD [s one match=(_clause _complex)]
	then [s]
	_xWILD [s one match=(_clause _complex)]
	_qEOS [s opt lookahead]
	_xEND
	@@

#
@POST
  if (!X("text out"))
    {
    G("oldout") << "\n\n" << "TEXT: " << X("$raw") << "\n";
    X("text out") = 1;
	}
  domifthen(N(3),N(8));
  noop();
@RULES
_xNIL <-
	_xSTART
	_fnword [s]
	_xWILD [s one match=(_clause _complex)]
	\, [s opt]
	_xWILD [s star match=(_adv _advl)]
	_fnword [s opt]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(_clause _complex)]
	\, [s opt]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s opt lookahead match=(_qEOS _fnword _xEND)]
	@@

# if clause  at end....
@POST
  if (!X("text out"))
    {
    G("oldout") << "\n\n" << "TEXT: " << X("$raw") << "\n";
    X("text out") = 1;
	}
  domcondition(N(4));
@RULES
_xNIL <-
	_xWILD [s one match=(when if)]
	_xWILD [s star match=(_adv _advl)]
	\, [s opt]
	_xWILD [s one match=(_clause _complex)]
	@@


# Simple clauses.
@POST
  if (!X("text out"))
    {
    G("oldout") << "\n\n" << "TEXT: " << X("$raw") << "\n";
    X("text out") = 1;
	}
  if (X("question"))
  	domquestion(N(2));
  else if (X("imperative"))
    domimperative(N(2));
  else
    domdeclarative(N(2));
  noop();
@RULES
_xNIL <-
	_xSTART
	_xWILD [one match=(_clause _complex)]
	_xEND
	@@

# Catch-all.
@POST
  if (!X("text out"))
    {
    G("oldout") << "\n\n" << "TEXT: " << X("$raw") << "\n";
    X("text out") = 1;
	}
  if (X("question") && !X("marked"))
    {
  	domquestion(N(1));
	X("marked") = 1;
	}
  else if (X("imperative") && !X("marked"))
    {
    domimperative(N(1));
	X("marked") = 1;
	}
  else
    domdeclarative(N(1));
  noop();
@RULES
_xNIL <-
	_xWILD [one match=(_clause _complex)]
	@@
