###############################################
# FILE: xmltraverse.pat
# SUBJ: Output text with embedded tags.
# AUTH: AM
# CREATED: 13/Dec/02 23:43:09
# NOTE:	Iterative traversal.  See xmlrecursive for recursive traversal.
###############################################

@CODE
exitpass();
		        
# Initialize traversal data.
L("parseRoot") = pnroot();
L("node")  = L("parseRoot");
L("depth") = 0;
L("path")  = 0;	# Stores the current path in the parse tree.
L("oend") = 0;	# Represents end offset of previously PRINTED node.

while (L("node"))	# Traverse the parse tree.
  {
  L("path")[L("depth")] = L("node");	# Update path in the parse tree.
  L("childs") = pndown(L("node"));
  L("next") = pnnext(L("node"));
  
  #################################
  # Test for node of interest here.
  L("name") = pnname(L("node"));
#  L("verbose") << L("name") << "\n";
  if (G("NP")	# Analyzer caller says to print out NP nodes.
   && (L("name") == "_nps" || L("name") == "_np") )
    {
	printfiller(L("node"),L("oend"),G("oxml"));
	xmlshort("np",pnvar(L("node"),"$raw"),G("oxml"));
	L("oend") = pnvar(L("node"),"$oend");	# Update right edge.
	L("childs") = 0;	# Don't traverse children.
	}
  else if (!L("childs"))	# Print out leaf of tree.
    {
	printfiller(L("node"),L("oend"),G("oxml"));
    G("oxml") << pnvar(L("node"),"$text");
	L("oend") = pnvar(L("node"),"$oend");	# Update right edge.
	}
  #################################

  if (L("childs"))                     # If node has children, traverse them.
     {
	 L("node") = L("childs");
	 ++L("depth");
	 }
  else if (L("next"))                  # If node has right sibling, get it.
     {
	 L("node") = L("next");
	 }
  else                                 # Try continuing from a parent.
     {
	 L("done") = 0;
	 L("node") = 0;
	 while (!L("done"))                # Find a continuation or quit.
	    {
		if (--L("depth") > 0)
		   {
		   L("node") = L("path")[L("depth")];	# Move up to parent.
		   if (L("node") = pnnext(L("node")))	# Try to move right.
		     L("done") = 1;
		   }
		else
		   L("done") = 1;
		}
	 }
  }

@@CODE

